unit AD12PHI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Label4: TLabel;
    Label5: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure  readCH0 ;
    PROCEDURE  READCH1 ;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  x: smallint;
  y: byte ;
  w: byte ;
  dat : byte ;
  pread : smallint ;
  pwrite: smallint ;
  ch0buff : smallint ;
  ch1buff : smallint ;

implementation

{$R *.DFM}
            procedure tform1.readCH0 ;
            begin
            ch0buff := 0 ;

            asm

                   pushf

                   mov dx,pwrite
                   mov al,$B
                   out dx,al

                   mov al,$3
                   out dx,al

                   mov al,$1
                   out dx,al

                   mov al,$3
                   out dx,al

                   mov al,$1
                   out dx,al

                   mov al,$3
                   out dx,al

                   mov al,$0
                   out dx,al

                   mov al,$2
                   out dx,al

                   mov al,$0
                   out dx,al

                   mov al,$2
                   out dx,al

                   mov ax,13

  @@ignor:         push ax      {  ignor  12  bit first }
                   mov al,$3
                   out dx,al
                   mov al,$1
                   out dx,al
                   pop ax
                   dec ax
                   jnz  @@ignor    { jump if AX not zero }

                                  { convert to  data }
                   mov ax,12
                   mov cl,0

  @@loopshift:     push ax

                   mov dx,pread
                   in  al,dx
                   and ax,$0080
                   shr ax,7      { shift  databit }

                   shl ax,cl
                   or  ch0buff,ax

                   mov dx,pwrite
                   mov  al,$3
                   out  dx,al
                   mov  al,$1
                   out  dx,al

                   pop  ax

                   inc cl
                   dec ax
                   jnz  @@loopshift  { jump if  AX  not  zero }
                   popf
                   end ;
           end ;

          procedure tform1.readCH1 ;
          begin
          ch1buff := 0 ;
          asm
                   pushf
                   mov dx,pwrite
                   mov al,$B
                   out dx,al
                   mov al,$3
                   out dx,al
                   mov al,$1
                   out dx,al
                   mov al,$3
                   out dx,al
                   mov al,$1
                   out dx,al
                   mov al,$3
                   out dx,al
                   mov al,$1
                   out dx,al
                   mov al,$3
                   out dx,al
                   mov al,$0
                   out dx,al
                   mov al,$2
                   out dx,al

                   mov ax,13
  @@ignor:         push ax
                   mov al,$3
                   out dx,al
                   mov al,$1
                   out dx,al
                   pop ax
                   dec ax
                   jnz  @@ignor

                   mov ax,12
                   mov cl,0
  @@loopshift:     push ax
                   mov dx,pread
                   in  al,dx
                   and ax,$0080
                   shr ax,7
                   shl ax,cl
                   or  ch1buff,ax
                   mov dx,pwrite
                   mov  al,$3
                   out  dx,al
                   mov  al,$1
                   out  dx,al
                   pop  ax
                   inc cl
                   dec ax
                   jnz  @@loopshift
                   popf
                   END;
      end ;

      procedure TForm1.FormPaint(Sender: TObject);
      begin
      canvas.moveto (20,40) ;
      canvas.lineto (20,255) ;
      canvas.moveto (20,255) ;
      canvas.lineto (400,255) ;  
      pread  := $379 ;
      pwrite := $378 ;
      end;

      procedure TForm1.Timer1Timer(Sender: TObject);
      var  factor0 : byte ;
           factor1 : BYTE ;
      begin
      refresh ;  { clear  screen }
      x := 20 ;
      for w := 1 to 80 do
      begin
      readCH0 ;
      readch1 ;
      label4.caption := inttostr(ch0buff ) ;
      label5.caption := inttostr(ch1buff ) ;
      factor0 := 255 - round (ch0buff / 20.6 ) ;
      factor1 := 255 - round (ch1buff / 20.6 ) ;
      canvas.pixels [x,factor0  ]:=clred     ;
      canvas.pixels [x,factor1  ]:=clblue     ;
      x := x + 4
      end ;
   end;

end.
